> For the complete documentation index, see [llms.txt](https://docs.konsist.lemonappdev.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.konsist.lemonappdev.com/inspiration/snippets/kotlin-serialization-snippets.md).

# Kotlin Serialization Snippets

Konsist can be used to guard the consistency of classes related to the \[Kotlin Serialization]\(<https://kotlinlang>. org/docs/serialization.html) library.

## 1. Classes Annotated With `Serializable` Have All Properties Annotated With `SerialName`

```kotlin
@Test
fun `classes annotated with 'Serializable' have all properties annotated with 'SerialName'`() {
    Konsist
        .scopeFromProject()
        .classes()
        .withAnnotationOf(Serializable::class)
        .properties()
        .assertTrue {
            it.hasAnnotationOf(SerialName::class)
        }
}
```

## 2. Enum Classes Annotated With `Serializable` Have All Enum Constants Annotated With `SerialName`

```kotlin
@Test
fun `enum classes annotated with 'Serializable' have all enum constants annotated with 'SerialName'`() {
    Konsist.scopeFromProject()
        .classes()
        .withEnumModifier()
        .withAnnotationOf(Serializable::class)
        .enumConstants
        .assertTrue { it.hasAnnotationOf(SerialName::class) }
}
```

## 3. All Models Are Serializable

```kotlin
@Test
fun `all models are serializable`() {
    Konsist
        .scopeFromPackage("com.myapp.model..")
        .classes()
        .assertTrue {
            it.hasAnnotationOf(Serializable::class)
        }
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.konsist.lemonappdev.com/inspiration/snippets/kotlin-serialization-snippets.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
